searchNodes=[{"doc":"Boruta is the core of an OAuth provider giving business logic of authentication and authorization.Documentation","ref":"Boruta.html","title":"Boruta","type":"module"},{"doc":"Utilities to access Boruta configuration ad set defaults.Configuration can be set as following in config.exs (this configuration is the default)config :boruta, Boruta.Oauth, repo: MyApp.Repo, # mandatory cache_backend: Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: MyApp.ResourceOwners, # mandatory for user flows scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24 ], token_generator: Boruta.TokenGenerator","ref":"Boruta.Config.html","title":"Boruta.Config","type":"module"},{"doc":"Boruta OAuth entrypoint, handles OAuth requests.Note : this module works in association with Boruta.Oauth.Application behaviour","ref":"Boruta.Oauth.html","title":"Boruta.Oauth","type":"module"},{"doc":"Process an authorize request and returns a token as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers authorize_success in case of success and authorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#authorize/3","title":"Boruta.Oauth.authorize/3","type":"function"},{"doc":"Process a introspect request as stated in RFC 7662 - OAuth 2.0 Token Introspection.Triggers introspect_success in case of success and introspect_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#introspect/2","title":"Boruta.Oauth.introspect/2","type":"function"},{"doc":"Process an authorize request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers preauthorize_success in case of success and preauthorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#preauthorize/3","title":"Boruta.Oauth.preauthorize/3","type":"function"},{"doc":"Process a revoke request as stated in RFC 7009 - OAuth 2.0 Token Revocation.Triggers revoke_success in case of success and revoke_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#revoke/2","title":"Boruta.Oauth.revoke/2","type":"function"},{"doc":"Process an token request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers token_success in case of success and token_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#token/2","title":"Boruta.Oauth.token/2","type":"function"},{"doc":"OAuth application behaviourImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.Application.html","title":"Boruta.Oauth.Application","type":"behaviour"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_error/2","title":"Boruta.Oauth.Application.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_success/2","title":"Boruta.Oauth.Application.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_error/2","title":"Boruta.Oauth.Application.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_success/2","title":"Boruta.Oauth.Application.introspect_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_error/2","title":"Boruta.Oauth.Application.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_success/2","title":"Boruta.Oauth.Application.preauthorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_error/2","title":"Boruta.Oauth.Application.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_success/1","title":"Boruta.Oauth.Application.revoke_success/1","type":"callback"},{"doc":"This function will be triggered in case of failure triggering Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_error/2","title":"Boruta.Oauth.Application.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success triggering Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_success/2","title":"Boruta.Oauth.Application.token_success/2","type":"callback"},{"doc":"Migration task for Boruta.Creates clients, scopes and tokens tables.Examplesmix boruta.gen.migration","ref":"Mix.Tasks.Boruta.Gen.Migration.html","title":"Mix.Tasks.Boruta.Gen.Migration","type":"task"},{"doc":"Authorize response","ref":"Boruta.Oauth.AuthorizeResponse.html","title":"Boruta.Oauth.AuthorizeResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#from_token/1","title":"Boruta.Oauth.AuthorizeResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#t:t/0","title":"Boruta.Oauth.AuthorizeResponse.t/0","type":"type"},{"doc":"Introspect response","ref":"Boruta.Oauth.IntrospectResponse.html","title":"Boruta.Oauth.IntrospectResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_error/1","title":"Boruta.Oauth.IntrospectResponse.from_error/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_token/1","title":"Boruta.Oauth.IntrospectResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#t:t/0","title":"Boruta.Oauth.IntrospectResponse.t/0","type":"type"},{"doc":"Token response","ref":"Boruta.Oauth.TokenResponse.html","title":"Boruta.Oauth.TokenResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#from_token/1","title":"Boruta.Oauth.TokenResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#t:t/0","title":"Boruta.Oauth.TokenResponse.t/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.Authorization.html","title":"Boruta.Oauth.Authorization","type":"protocol"},{"doc":"Checks if request is valid for token creation for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#preauthorize/1","title":"Boruta.Oauth.Authorization.preauthorize/1","type":"function"},{"doc":"Creates and returns a token for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#token/1","title":"Boruta.Oauth.Authorization.token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.html#t:t/0","title":"Boruta.Oauth.Authorization.t/0","type":"type"},{"doc":"Access token authorization","ref":"Boruta.Oauth.Authorization.AccessToken.html","title":"Boruta.Oauth.Authorization.AccessToken","type":"module"},{"doc":"Authorize the access token corresponding to the given params.Examplesiex&gt; authorize(%{value: &quot;value&quot;}) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.AccessToken.html#authorize/1","title":"Boruta.Oauth.Authorization.AccessToken.authorize/1","type":"function"},{"doc":"Client authorization","ref":"Boruta.Oauth.Authorization.Client.html","title":"Boruta.Oauth.Authorization.Client","type":"module"},{"doc":"Authorize the client corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;, secret: &quot;secret&quot;) {:ok, %Boruta.Oauth.Client{...}}","ref":"Boruta.Oauth.Authorization.Client.html#authorize/1","title":"Boruta.Oauth.Authorization.Client.authorize/1","type":"function"},{"doc":"Code authorization","ref":"Boruta.Oauth.Authorization.Code.html","title":"Boruta.Oauth.Authorization.Code","type":"module"},{"doc":"Authorize the code corresponding to the given params.Examplesiex&gt; authorize(value: &quot;value&quot;, redirect_uri: &quot;redirect_uri&quot;) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.Code.html#authorize/1","title":"Boruta.Oauth.Authorization.Code.authorize/1","type":"function"},{"doc":"Resource owner authorization","ref":"Boruta.Oauth.Authorization.ResourceOwner.html","title":"Boruta.Oauth.Authorization.ResourceOwner","type":"module"},{"doc":"Authorize the resource owner corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;) {:ok, %User{...}}","ref":"Boruta.Oauth.Authorization.ResourceOwner.html#authorize/1","title":"Boruta.Oauth.Authorization.ResourceOwner.authorize/1","type":"function"},{"doc":"Scope authorization","ref":"Boruta.Oauth.Authorization.Scope.html","title":"Boruta.Oauth.Authorization.Scope","type":"module"},{"doc":"Authorize the given scope according to the given client.Examplesiex&gt; authorize(%{scope: &quot;scope&quot;, client: %Client{...}}) {:ok, &quot;scope&quot;}","ref":"Boruta.Oauth.Authorization.Scope.html#authorize/1","title":"Boruta.Oauth.Authorization.Scope.authorize/1","type":"function"},{"doc":"Struct encapsulating an authorization success","ref":"Boruta.Oauth.AuthorizationSuccess.html","title":"Boruta.Oauth.AuthorizationSuccess","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizationSuccess.html#t:t/0","title":"Boruta.Oauth.AuthorizationSuccess.t/0","type":"type"},{"doc":"OAuth Introspect","ref":"Boruta.Oauth.Introspect.html","title":"Boruta.Oauth.Introspect","type":"module"},{"doc":"Returns corresponding token for the given Boruta.Oauth.IntrospectRequestNote : Invalid tokens returns an error {:error, %Error{error: :invalid_access_token, ...}}. That must be rescued to return %{&quot;active&quot; =&gt; false} in application implementation.Examplesiex&gt; token(%IntrospectRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) {:ok, %Token{...}}","ref":"Boruta.Oauth.Introspect.html#token/1","title":"Boruta.Oauth.Introspect.token/1","type":"function"},{"doc":"OAuth Revoke","ref":"Boruta.Oauth.Revoke.html","title":"Boruta.Oauth.Revoke","type":"module"},{"doc":"Revokes token according to the given Boruta.Oauth.RevokeRequestExamplesiex&gt; token(%RevokeRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) :ok","ref":"Boruta.Oauth.Revoke.html#token/1","title":"Boruta.Oauth.Revoke.token/1","type":"function"},{"doc":"Access token context","ref":"Boruta.Oauth.AccessTokens.html","title":"Boruta.Oauth.AccessTokens","type":"behaviour"},{"doc":"Persists a token with the given params.","ref":"Boruta.Oauth.AccessTokens.html#c:create/2","title":"Boruta.Oauth.AccessTokens.create/2","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token either by value or refresh_token.","ref":"Boruta.Oauth.AccessTokens.html#c:get_by/1","title":"Boruta.Oauth.AccessTokens.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token.","ref":"Boruta.Oauth.AccessTokens.html#c:revoke/1","title":"Boruta.Oauth.AccessTokens.revoke/1","type":"callback"},{"doc":"Client context","ref":"Boruta.Oauth.Clients.html","title":"Boruta.Oauth.Clients","type":"behaviour"},{"doc":"Returns client authorized scopes. The scopes will be granted for every requests to the given client.","ref":"Boruta.Oauth.Clients.html#c:authorized_scopes/1","title":"Boruta.Oauth.Clients.authorized_scopes/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Client by either id and secret ou by id and redirect_uri.","ref":"Boruta.Oauth.Clients.html#c:get_by/1","title":"Boruta.Oauth.Clients.get_by/1","type":"callback"},{"doc":"Code context","ref":"Boruta.Oauth.Codes.html","title":"Boruta.Oauth.Codes","type":"behaviour"},{"doc":"Persists a token according to given params.","ref":"Boruta.Oauth.Codes.html#c:create/1","title":"Boruta.Oauth.Codes.create/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token by value and redirect_uri.","ref":"Boruta.Oauth.Codes.html#c:get_by/1","title":"Boruta.Oauth.Codes.get_by/1","type":"callback"},{"doc":"Resource owner context","ref":"Boruta.Oauth.ResourceOwners.html","title":"Boruta.Oauth.ResourceOwners","type":"behaviour"},{"doc":"Returns a list of authorized scopes for a given resource owner. These scopes will be granted is requested for the user.","ref":"Boruta.Oauth.ResourceOwners.html#c:authorized_scopes/1","title":"Boruta.Oauth.ResourceOwners.authorized_scopes/1","type":"callback"},{"doc":"Determines if given password is correct.","ref":"Boruta.Oauth.ResourceOwners.html#c:check_password/2","title":"Boruta.Oauth.ResourceOwners.check_password/2","type":"callback"},{"doc":"Returns a resource owner by (username, password) or (id). Returns nil for non matching results.","ref":"Boruta.Oauth.ResourceOwners.html#c:get_by/1","title":"Boruta.Oauth.ResourceOwners.get_by/1","type":"callback"},{"doc":"Scope context","ref":"Boruta.Oauth.Scopes.html","title":"Boruta.Oauth.Scopes","type":"behaviour"},{"doc":"","ref":"Boruta.Oauth.Scopes.html#c:public/0","title":"Boruta.Oauth.Scopes.public/0","type":"callback"},{"doc":"OAuth client schema","ref":"Boruta.Oauth.Client.html","title":"Boruta.Oauth.Client","type":"module"},{"doc":"","ref":"Boruta.Oauth.Client.html#t:t/0","title":"Boruta.Oauth.Client.t/0","type":"type"},{"doc":"Oauth resource owner","ref":"Boruta.Oauth.ResourceOwner.html","title":"Boruta.Oauth.ResourceOwner","type":"module"},{"doc":"","ref":"Boruta.Oauth.ResourceOwner.html#t:t/0","title":"Boruta.Oauth.ResourceOwner.t/0","type":"type"},{"doc":"Schema defining an independent OAuth scope","ref":"Boruta.Oauth.Scope.html","title":"Boruta.Oauth.Scope","type":"module"},{"doc":"Splits an OAuth scope string into individual scopes as stringExamplesiex&gt; scope(&quot;a:scope another:scope&quot;) [&quot;a:scope&quot;, &quot;another:scope&quot;]","ref":"Boruta.Oauth.Scope.html#split/1","title":"Boruta.Oauth.Scope.split/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:t/0","title":"Boruta.Oauth.Scope.t/0","type":"type"},{"doc":"Token schema. Representing both access tokens and codes.","ref":"Boruta.Oauth.Token.html","title":"Boruta.Oauth.Token","type":"module"},{"doc":"Determines if a token is expiredExamplesiex&gt; expired?(%Boruta.Oauth.Token{expires_at: 1638316800}) # 1st january 2021 :ok iex&gt; expired?(%Boruta.Oauth.Token{expires_at: 0}) # 1st january 1970 {:error, &quot;Token expired.&quot;}","ref":"Boruta.Oauth.Token.html#expired?/1","title":"Boruta.Oauth.Token.expired?/1","type":"function"},{"doc":"Returns an hexadecimal SHA512 hash of given stringExamplesiex&gt; hash(&quot;foo&quot;) &quot;F7FBBA6E0636F890E56FBBF3283E524C6FA3204AE298382D624741D0DC6638326E282C41BE5E4254D8820772C5518A2C5A8C0C7F7EDA19594A7EB539453E1ED7&quot;","ref":"Boruta.Oauth.Token.html#hash/1","title":"Boruta.Oauth.Token.hash/1","type":"function"},{"doc":"Determines if a token is revoked.Examplesiex&gt; revoked?(%Boruta.Oauth.Token{revoked_at: nil}) :ok iex&gt; revoked?(%Boruta.Oauth.Token{}) {:error, &quot;Token revoked.&quot;}","ref":"Boruta.Oauth.Token.html#revoked?/1","title":"Boruta.Oauth.Token.revoked?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Token.html#t:t/0","title":"Boruta.Oauth.Token.t/0","type":"type"},{"doc":"Authorization code request","ref":"Boruta.Oauth.AuthorizationCodeRequest.html","title":"Boruta.Oauth.AuthorizationCodeRequest","type":"module"},{"doc":"Type representing an authorization code request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.AuthorizationCodeRequest.html#t:t/0","title":"Boruta.Oauth.AuthorizationCodeRequest.t/0","type":"type"},{"doc":"Client credentials request","ref":"Boruta.Oauth.ClientCredentialsRequest.html","title":"Boruta.Oauth.ClientCredentialsRequest","type":"module"},{"doc":"Type representing a client credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.ClientCredentialsRequest.html#t:t/0","title":"Boruta.Oauth.ClientCredentialsRequest.t/0","type":"type"},{"doc":"Code request","ref":"Boruta.Oauth.CodeRequest.html","title":"Boruta.Oauth.CodeRequest","type":"module"},{"doc":"Type representing a code request as stated in OAuth 2.0 RFC.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.CodeRequest.html#t:t/0","title":"Boruta.Oauth.CodeRequest.t/0","type":"type"},{"doc":"Introspect request","ref":"Boruta.Oauth.IntrospectRequest.html","title":"Boruta.Oauth.IntrospectRequest","type":"module"},{"doc":"Type representing an introspect request as stated in Introspect RFC.","ref":"Boruta.Oauth.IntrospectRequest.html#t:t/0","title":"Boruta.Oauth.IntrospectRequest.t/0","type":"type"},{"doc":"Resource owner password credentials request","ref":"Boruta.Oauth.PasswordRequest.html","title":"Boruta.Oauth.PasswordRequest","type":"module"},{"doc":"Type representing a resource owner password credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.PasswordRequest.html#t:t/0","title":"Boruta.Oauth.PasswordRequest.t/0","type":"type"},{"doc":"Refresh token request","ref":"Boruta.Oauth.RefreshTokenRequest.html","title":"Boruta.Oauth.RefreshTokenRequest","type":"module"},{"doc":"Type representing a refresh token request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.RefreshTokenRequest.html#t:t/0","title":"Boruta.Oauth.RefreshTokenRequest.t/0","type":"type"},{"doc":"Build an oauth request struct from given input.Note : Input must have the shape or be a %Plug.Conn{} request.","ref":"Boruta.Oauth.Request.html","title":"Boruta.Oauth.Request","type":"module"},{"doc":"Create request struct from an OAuth authorize request.Note : resource owner must be provided as current_user assigns.Examplesiex&gt;authorize_request( %{ query_params: %{ &quot;response_type&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;redirect_uri&quot; =&gt; &quot;redirect_uri&quot; }, }, %User{...} ) {:ok, %TokenRequest{...}}","ref":"Boruta.Oauth.Request.html#authorize_request/2","title":"Boruta.Oauth.Request.authorize_request/2","type":"function"},{"doc":"Create request struct from an OAuth introspect request.Examplesiex&gt;introspect_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %IntrospectRequest{...}}","ref":"Boruta.Oauth.Request.html#introspect_request/1","title":"Boruta.Oauth.Request.introspect_request/1","type":"function"},{"doc":"Create request struct from an OAuth revoke request.Examplesiex&gt;revoke_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %RevokeRequest{...}}","ref":"Boruta.Oauth.Request.html#revoke_request/1","title":"Boruta.Oauth.Request.revoke_request/1","type":"function"},{"doc":"Create request struct from an OAuth token request.Examplesiex&gt;token_request(%{ body_params: %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } }) {:ok, %ClientCredentialsRequest{...}}","ref":"Boruta.Oauth.Request.html#token_request/1","title":"Boruta.Oauth.Request.token_request/1","type":"function"},{"doc":"Revoke request","ref":"Boruta.Oauth.RevokeRequest.html","title":"Boruta.Oauth.RevokeRequest","type":"module"},{"doc":"Type representing an revoke request as stated in OAuth 2.0 Token revocation RFC.","ref":"Boruta.Oauth.RevokeRequest.html#t:t/0","title":"Boruta.Oauth.RevokeRequest.t/0","type":"type"},{"doc":"Implicit request","ref":"Boruta.Oauth.TokenRequest.html","title":"Boruta.Oauth.TokenRequest","type":"module"},{"doc":"Type representing an implicit request as stated in OAuth 2.0 RFC.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.TokenRequest.html#t:t/0","title":"Boruta.Oauth.TokenRequest.t/0","type":"type"},{"doc":"Administration of Boruta resources.","ref":"Boruta.Ecto.Admin.html","title":"Boruta.Ecto.Admin","type":"module"},{"doc":"See Boruta.Ecto.Admin.Clients.create_client/1.","ref":"Boruta.Ecto.Admin.html#create_client/1","title":"Boruta.Ecto.Admin.create_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.create_scope/1.","ref":"Boruta.Ecto.Admin.html#create_scope/1","title":"Boruta.Ecto.Admin.create_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.delete_client/1.","ref":"Boruta.Ecto.Admin.html#delete_client/1","title":"Boruta.Ecto.Admin.delete_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.delete_scope/1.","ref":"Boruta.Ecto.Admin.html#delete_scope/1","title":"Boruta.Ecto.Admin.delete_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.get_client!/1.","ref":"Boruta.Ecto.Admin.html#get_client!/1","title":"Boruta.Ecto.Admin.get_client!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scope!/1.","ref":"Boruta.Ecto.Admin.html#get_scope!/1","title":"Boruta.Ecto.Admin.get_scope!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1.","ref":"Boruta.Ecto.Admin.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.get_scopes_by_ids/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.list_clients/0.","ref":"Boruta.Ecto.Admin.html#list_clients/0","title":"Boruta.Ecto.Admin.list_clients/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.list_scopes/0.","ref":"Boruta.Ecto.Admin.html#list_scopes/0","title":"Boruta.Ecto.Admin.list_scopes/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.update_client/2.","ref":"Boruta.Ecto.Admin.html#update_client/2","title":"Boruta.Ecto.Admin.update_client/2","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.update_scope/2.","ref":"Boruta.Ecto.Admin.html#update_scope/2","title":"Boruta.Ecto.Admin.update_scope/2","type":"function"},{"doc":"Boruta.Ecto.Client resource administration.","ref":"Boruta.Ecto.Admin.Clients.html","title":"Boruta.Ecto.Admin.Clients","type":"module"},{"doc":"Creates a client.Examplesiex&gt; create_client(%{field: value}) {:ok, %Client{}} iex&gt; create_client(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#create_client/1","title":"Boruta.Ecto.Admin.Clients.create_client/1","type":"function"},{"doc":"Deletes a Client.Examplesiex&gt; delete_client(client) {:ok, %Client{}} iex&gt; delete_client(client) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#delete_client/1","title":"Boruta.Ecto.Admin.Clients.delete_client/1","type":"function"},{"doc":"Gets a single client.Raises Ecto.NoResultsError if the Client does not exist.Examplesiex&gt; get_client!(123) %Client{} iex&gt; get_client!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Clients.html#get_client!/1","title":"Boruta.Ecto.Admin.Clients.get_client!/1","type":"function"},{"doc":"Returns the list of clients.Examplesiex&gt; list_clients() [%Client{}, ...]","ref":"Boruta.Ecto.Admin.Clients.html#list_clients/0","title":"Boruta.Ecto.Admin.Clients.list_clients/0","type":"function"},{"doc":"Updates a client.Examplesiex&gt; update_client(client, %{field: new_value}) {:ok, %Client{}} iex&gt; update_client(client, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#update_client/2","title":"Boruta.Ecto.Admin.Clients.update_client/2","type":"function"},{"doc":"Boruta.Ecto.Scope resource administration.","ref":"Boruta.Ecto.Admin.Scopes.html","title":"Boruta.Ecto.Admin.Scopes","type":"module"},{"doc":"Creates a scope.Examplesiex&gt; create_scope(%{field: value}) {:ok, %Scope{}} iex&gt; create_scope(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#create_scope/1","title":"Boruta.Ecto.Admin.Scopes.create_scope/1","type":"function"},{"doc":"Deletes a Scope.Examplesiex&gt; delete_scope(scope) {:ok, %Scope{}} iex&gt; delete_scope(scope) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#delete_scope/1","title":"Boruta.Ecto.Admin.Scopes.delete_scope/1","type":"function"},{"doc":"Gets a single scope.Raises Ecto.NoResultsError if the Scope does not exist.Examplesiex&gt; get_scope!(123) %Scope{} iex&gt; get_scope!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Scopes.html#get_scope!/1","title":"Boruta.Ecto.Admin.Scopes.get_scope!/1","type":"function"},{"doc":"","ref":"Boruta.Ecto.Admin.Scopes.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1","type":"function"},{"doc":"Returns the list of scopes.Examplesiex&gt; list_scopes() [%Scope{}, ...]","ref":"Boruta.Ecto.Admin.Scopes.html#list_scopes/0","title":"Boruta.Ecto.Admin.Scopes.list_scopes/0","type":"function"},{"doc":"Updates a scope.Examplesiex&gt; update_scope(scope, %{field: new_value}) {:ok, %Scope{}} iex&gt; update_scope(scope, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#update_scope/2","title":"Boruta.Ecto.Admin.Scopes.update_scope/2","type":"function"},{"doc":"HTTP BasicAuth utilitiesProvide utilities to decode Basic authorization header as stated in RFC 7617 - The 'Basic' HTTP Authentication Scheme","ref":"Boruta.BasicAuth.html","title":"Boruta.BasicAuth","type":"module"},{"doc":"Decode given authorization header and returns an array containing username and password.Examplesiex&gt; Boruta.BasicAuth.decode(&quot;Basic dXNlcm5hbWU6cGFzc3dvcmQ=&quot;) {:ok, [&quot;username&quot;, &quot;password&quot;]} iex&gt; Boruta.BasicAuth.decode(&quot;bad_authorization_header&quot;) {:error, &quot;`bad_authorization_header` is not a valid Basic authorization header.&quot;}","ref":"Boruta.BasicAuth.html#decode/1","title":"Boruta.BasicAuth.decode/1","type":"function"},{"doc":"This is the cache for the primary storage.","ref":"Boruta.Cache.Primary.html","title":"Boruta.Cache.Primary","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"Boruta.Cache.Primary.html#generations/0","title":"Boruta.Cache.Primary.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"Boruta.Cache.Primary.html#new_generation/1","title":"Boruta.Cache.Primary.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"Boruta.Cache.Primary.html#newer_generation/0","title":"Boruta.Cache.Primary.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"Boruta.Cache.Primary.html#reset_generation_timer/0","title":"Boruta.Cache.Primary.reset_generation_timer/0","type":"function"},{"doc":"Behaviour to implement utilities to generate token value. This must be implemented in the module configured as token_generator set in config.exs","ref":"Boruta.Oauth.TokenGenerator.html","title":"Boruta.Oauth.TokenGenerator","type":"behaviour"},{"doc":"Generates a token value from token entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:generate/2","title":"Boruta.Oauth.TokenGenerator.generate/2","type":"callback"},{"doc":"Generates a secret from client entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:secret/1","title":"Boruta.Oauth.TokenGenerator.secret/1","type":"callback"},{"doc":"Utility to validate the request according to the given parameters.","ref":"Boruta.Oauth.Validator.html","title":"Boruta.Oauth.Validator","type":"module"},{"doc":"Validates given OAuth parameters.Examplesiex&gt; validate(%{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }) {:ok, %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }} iex&gt; validate(%{}) {:error, &quot;Request is not a valid OAuth request. Need a grant_type or a response_type param.&quot;}","ref":"Boruta.Oauth.Validator.html#validate/2","title":"Boruta.Oauth.Validator.validate/2","type":"function"},{"doc":"Boruta OAuth errorsIntended to follow OAuth 2.0 errors. Additionnal errors are provided as purpose.","ref":"Boruta.Oauth.Error.html","title":"Boruta.Oauth.Error","type":"module"},{"doc":"","ref":"Boruta.Oauth.Error.html#with_format/2","title":"Boruta.Oauth.Error.with_format/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Error.html#t:t/0","title":"Boruta.Oauth.Error.t/0","type":"type"},{"doc":"Boruta OAuth provider coreBoruta is the core of an OAuth provider giving business logic of authentication and authorization.It is intended to follow RFCs:RFC 6749 - The OAuth 2.0 Authorization FrameworkRFC 7662 - OAuth 2.0 Token IntrospectionRFC 7009 - OAuth 2.0 Token RevocationRFC 7636 - Proof Key for Code Exchange by OAuth Public ClientsAs it, it helps implement a provider for authorization code, implicit, client credentials and resource owner password credentials grants. Then it follows Introspection to check tokens.","ref":"readme.html","title":"Boruta OAuth provider core","type":"extras"},{"doc":"Documentation can be found here","ref":"readme.html#documentation","title":"Boruta OAuth provider core - Documentation","type":"extras"},{"doc":"A live example can be found here","ref":"readme.html#live-example","title":"Boruta OAuth provider core - Live example","type":"extras"},{"doc":"Schemas migrationIf you plan to use Boruta builtin clients and tokens contexts, you'll need a migration for its Ecto schemas. This can be done by running:mix boruta.gen.migrationImplement ResourceOwners contextIn order to have user flows working, You need to implement Boruta.Oauth.ResourceOwners.Here is an example implementation:defmodule MyApp.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by(username: username) do with %User{id: id, email: email} &lt;- Repo.get_by(User, email: username) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end def get_by(sub: sub) do with %User{id: id, email: email} = user &lt;- Repo.get_by(User, id: sub) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end @impl Boruta.Oauth.ResourceOwners def check_password(resource_owner, password) do User.check_password(user, password) end @impl Boruta.Oauth.ResourceOwners def authorized_scopes(%ResourceOwner{}), do: [] endConfigurationBoruta provides several configuration options, to customize them you can add configurations in config.exs as followingconfig :boruta, Boruta.Oauth, repo: MyApp.Repo, # mandatory cache_backend: Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: MyApp.ResourceOwners, # mandatory for user flows scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24 ], token_generator: Boruta.TokenGenerator","ref":"readme.html#setup","title":"Boruta OAuth provider core - Setup","type":"extras"},{"doc":"This implementation follows an hexagonal architecture to invert dependencies to Application layer. In order to expose endpoints of an OAuth server with Boruta, you need implement the behaviour Boruta.Oauth.Application with all needed callbacks for token/2, authorize/2, introspect/2 and revoke/2 calls from Boruta.Oauth.This library has specific interfaces to interact with Plug.Conn requests.Here is an example of a token endpoint controller:defmodule MyApp.OauthController do @behaviour Boruta.Oauth.Application ... def token(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.token(__MODULE__) end @impl Boruta.Oauth.Application def token_success(conn, %TokenResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;token.json&quot;, response: response) end @impl Boruta.Oauth.Application def token_error(conn, %Error{status: status, error: error, error_description: error_description}) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end ... end","ref":"readme.html#integration","title":"Boruta OAuth provider core - Integration","type":"extras"},{"doc":"You can also create a client and test italias Boruta.Ecto alias Boruta.Oauth.Authorization alias Boruta.Oauth.{ClientCredentialsRequest, Token} # create a client {:ok, %Ecto.Client{id: client_id, secret: client_secret}} = Ecto.Admin.create_client(%{authorization_code_ttl: 60, access_token_ttl: 60 * 60}) # obtain a token {:ok, %Token{value: value}} = Authorization.token(%ClientCredentialsRequest{client_id: client_id, client_secret: client_secret}) # check token {:ok, _token} = Authorization.AccessToken.authorize(value: value)","ref":"readme.html#straightforward-testing","title":"Boruta OAuth provider core - Straightforward testing","type":"extras"},{"doc":"Some integration guides are provided as code samples.Authorization code grantClient Credentials grantImplicit grantResource Owner Password Credentials grantIntrospectRevoke","ref":"readme.html#guides","title":"Boruta OAuth provider core - Guides","type":"extras"},{"doc":"It is a work in progress, all feedbacks / feature requests / improvements are welcome","ref":"readme.html#feedback","title":"Boruta OAuth provider core - Feedback","type":"extras"},{"doc":"Client credentials grantAs stated in OAuth 2.0 RFC Client credentials grant is a flow involving servers in order for them to get access tokens. +---------+ +---------------+ | | | | | |&gt;--(A)- Client Authentication ---&gt;| Authorization | | Client | | Server | | |&lt;--(B)---- Access Token ---------&lt;| | | | | | +---------+ +---------------+(A) The client authenticates with the authorization server and requests an access token from the token endpoint.(B) The authorization server authenticates the client, and if valid, issues an access token.Copyright (c) 2012 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"client_credentials.html","title":"Client credentials grant","type":"extras"},{"doc":"Code examplelib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view alias Boruta.Oauth.TokenResponse def render(&quot;token.json&quot;, %{ response: %TokenResponse{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } }) do %{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } end def render(&quot;error.json&quot;, %{error: error, error_description: error_description}) do %{ error: error, error_description: error_description } end endlib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias Boruta.Oauth.TokenResponse alias MyAppWeb.OauthView def token(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.token(__MODULE__) end @impl Boruta.Oauth.Application def token_success(conn, %TokenResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;token.json&quot;, response: response) end @impl Boruta.Oauth.Application def token_error(conn, %Error{status: status, error: error, error_description: error_description}) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/oauth&quot;, MyAppWeb do pipe_through :api post &quot;/token&quot;, OauthController, :token end end","ref":"client_credentials.html#integration","title":"Client credentials grant - Integration","type":"extras"},{"doc":"Resource Owner Password Credentials grantAs stated in OAuth 2.0 RFC Resource owner password credentials grant is a flow issuing access tokens for a resource owner by providing its credentials. +----------+ | Resource | | Owner | | | +----------+ v | Resource Owner (A) Password Credentials | v +---------+ +---------------+ | |&gt;--(B)---- Resource Owner -------&gt;| | | | Password Credentials | Authorization | | Client | | Server | | |&lt;--(C)---- Access Token ---------&lt;| | | | (w/ Optional Refresh Token) | | +---------+ +---------------+(A) The resource owner provides the client with its username and password.(B) The client requests an access token from the authorization server's token endpoint by including the credentials received from the resource owner. When making the request, the client authenticates with the authorization server.(C) The authorization server authenticates the client and validates the resource owner credentials, and if valid, issues an access token.Copyright (c) 2012 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"resource_owner_password_credentials.html","title":"Resource Owner Password Credentials grant","type":"extras"},{"doc":"Code examplelib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view alias Boruta.Oauth.TokenResponse def render(&quot;token.json&quot;, %{ response: %TokenResponse{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } }) do %{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } end def render(&quot;error.json&quot;, %{error: error, error_description: error_description}) do %{ error: error, error_description: error_description } end endlib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias Boruta.Oauth.TokenResponse alias MyAppWeb.OauthView def token(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.token(__MODULE__) end @impl Boruta.Oauth.Application def token_success(conn, %TokenResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;token.json&quot;, response: response) end @impl Boruta.Oauth.Application def token_error(conn, %Error{status: status, error: error, error_description: error_description}) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/oauth&quot;, MyAppWeb do pipe_through :api post &quot;/token&quot;, OauthController, :token end end","ref":"resource_owner_password_credentials.html#integration","title":"Resource Owner Password Credentials grant - Integration","type":"extras"},{"doc":"Authorization code grantAs stated in OAuth 2.0 RFC Authorization code grant is a secure flow (recommanded) involving user agent and client in order to get access tokens. +----------+ | Resource | | Owner | | | +----------+ ^ | (B) +----|-----+ Client Identifier +---------------+ | -+----(A)-- &amp; Redirection URI ----&gt;| | | User- | | Authorization | | Agent -+----(B)-- User authenticates ---&gt;| Server | | | | | | -+----(C)-- Authorization Code ---&lt;| | +-|----|---+ +---------------+ | | ^ v (A) (C) | | | | | | ^ v | | +---------+ | | | |&gt;---(D)-- Authorization Code ---------&#39; | | Client | &amp; Redirection URI | | | | | |&lt;---(E)----- Access Token -------------------&#39; +---------+ (w/ Optional Refresh Token)(A) The client initiates the flow by directing the resource owner's user-agent to the authorization endpoint. The client includes its client identifier, requested scope, local state, and a redirection URI to which the authorization server will send the user-agent back once access is granted (or denied).(B) The authorization server authenticates the resource owner (via the user-agent) and establishes whether the resource owner grants or denies the client's access request.(C) Assuming the resource owner grants access, the authorization server redirects the user-agent back to the client using the redirection URI provided earlier (in the request or during client registration). The redirection URI includes an authorization code and any local state provided by the client earlier.(D) The client requests an access token from the authorization server's token endpoint by including the authorization code received in the previous step. When making the request, the client authenticates with the authorization server. The client includes the redirection URI used to obtain the authorization code for verification.(E) The authorization server authenticates the client, validates the authorization code, and ensures that the redirection URI received matches the URI used to redirect the client in step (C). If valid, the authorization server responds back with an access token and, optionally, a refresh token.Copyright (c) 2012 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"authorization_code.html","title":"Authorization code grant","type":"extras"},{"doc":"Code examplelib/my_app_web/resource_owners.exdefmodule MyApp.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by(username: username) do with %User{id: id, email: email} &lt;- Repo.get_by(User, email: username) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end def get_by(sub: sub) do with %User{id: id, email: email} = user &lt;- Repo.get_by(User, id: sub) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end @impl Boruta.Oauth.ResourceOwners def check_password(resource_owner, password) do User.check_password(user, password) end @impl Boruta.Oauth.ResourceOwners def authorized_scopes(%ResourceOwner{}), do: [] endlib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view alias Boruta.Oauth.TokenResponse def render(&quot;token.json&quot;, %{ response: %TokenResponse{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } }) do %{ token_type: token_type, access_token: access_token, expires_in: expires_in, refresh_token: refresh_token } end def render(&quot;error.json&quot;, %{error: error, error_description: error_description}) do %{ error: error, error_description: error_description } end endlib/my_app_web/templates/oauth/error.html.eex&lt;h1&gt;&lt;%= @error %&gt; - An error occured while authorizing request, check client OAuth configuration&lt;/h1&gt; &lt;p&gt;&lt;%= @error_description %&gt;&lt;/p&gt;lib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias Boruta.Oauth.TokenResponse alias MyAppWeb.OauthView def token(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.token(__MODULE__) end @impl Boruta.Oauth.Application def token_success(conn, %TokenResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;token.json&quot;, response: response) end @impl Boruta.Oauth.Application def token_error(conn, %Error{status: status, error: error, error_description: error_description}) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end def authorize(%Plug.Conn{query_params: query_params} = conn, _params) do current_user = conn.assigns[:current_user] conn = store_user_return_to(conn, query_params) Oauth.authorize( %ResourceOwner{sub: current_user.id, username: current_user.email}, conn, __MODULE__ ) end @impl Boruta.Oauth.Application def authorize_success( conn, %AuthorizeResponse{ type: type, redirect_uri: redirect_uri, value: value, expires_in: expires_in, state: state } ) do query_string = case state do nil -&gt; URI.encode_query(%{type =&gt; value, &quot;expires_in&quot; =&gt; expires_in}) state -&gt; URI.encode_query(%{type =&gt; value, &quot;expires_in&quot; =&gt; expires_in, &quot;state&quot; =&gt; state}) end url = case type do &quot;access_token&quot; -&gt; &quot;\#{redirect_uri}#\#{query_string}&quot; &quot;code&quot; -&gt; &quot;\#{redirect_uri}?\#{query_string}&quot; end redirect(conn, external: url) end @impl Boruta.Oauth.Application def authorize_error( conn, %Error{status: :unauthorized, error: :invalid_resource_owner} ) do # NOTE after siging in the user shall be redirected to `get_session(conn, :user_return_to)` redirect(conn, to: Routes.user_session_path(:new)) end def authorize_error( conn, %Error{ error: error, error_description: error_description, format: format, redirect_uri: redirect_uri } ) do query_string = URI.encode_query(%{error: error, error_description: error_description}) case format do :query -&gt; url = &quot;\#{redirect_uri}?\#{query_string}&quot; redirect(conn, external: url) :fragment -&gt; url = &quot;\#{redirect_uri}#\#{query_string}&quot; redirect(conn, external: url) _ -&gt; conn |&gt; put_status(status) |&gt; put_view(MyAppWeb.OauthView) |&gt; render(&quot;error.html&quot;, error: error, error_description: error_description) end end defp store_user_return_to(conn, params) do conn |&gt; put_session( :user_return_to, Routes.oauth_path(conn, :authorize, client_id: params[&quot;client_id&quot;], redirect_uri: params[&quot;redirect_uri&quot;], response_type: params[&quot;response_type&quot;], scope: params[&quot;scope&quot;], state: params[&quot;state&quot;] ) ) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :put_secure_browser_headers end pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/oauth&quot;, MyAppWeb do pipe_through :api post &quot;/token&quot;, OauthController, :token end scope &quot;/oauth&quot;, MyAppWeb do pipe_through [ :browser, :fetch_current_user # Out of OAuth scope, shall assign current_user to conn ] get &quot;/authorize&quot;, OauthController, :authorize end end","ref":"authorization_code.html#integration","title":"Authorization code grant - Integration","type":"extras"},{"doc":"Implicit grantAs stated in OAuth 2.0 RFC Implicit grant is a flow suitable for javascript applications, ensuring client validity with its provided TLS certificate. +----------+ | Resource | | Owner | | | +----------+ ^ | (B) +----|-----+ Client Identifier +---------------+ | -+----(A)-- &amp; Redirection URI ---&gt;| | | User- | | Authorization | | Agent -|----(B)-- User authenticates --&gt;| Server | | | | | | |&lt;---(C)--- Redirection URI ----&lt;| | | | with Access Token +---------------+ | | in Fragment | | +---------------+ | |----(D)--- Redirection URI ----&gt;| Web-Hosted | | | without Fragment | Client | | | | Resource | | (F) |&lt;---(E)------- Script ---------&lt;| | | | +---------------+ +-|--------+ | | (A) (G) Access Token | | ^ v +---------+ | | | Client | | | +---------+(A) The client initiates the flow by directing the resource owner's user-agent to the authorization endpoint. The client includes its client identifier, requested scope, local state, and a redirection URI to which the authorization server will send the user-agent back once access is granted (or denied).(B) The authorization server authenticates the resource owner (via the user-agent) and establishes whether the resource owner grants or denies the client's access request.(C) Assuming the resource owner grants access, the authorization server redirects the user-agent back to the client using the redirection URI provided earlier. The redirection URI includes the access token in the URI fragment.(D) The user-agent follows the redirection instructions by making a request to the web-hosted client resource (which does not include the fragment per [RFC2616]). The user-agent retains the fragment information locally.(E) The web-hosted client resource returns a web page (typically an HTML document with an embedded script) capable of accessing the full redirection URI including the fragment retained by the user-agent, and extracting the access token (and other parameters) contained in the fragment.(F) The user-agent executes the script provided by the web-hosted client resource locally, which extracts the access token.(G) The user-agent passes the access token to the client.Copyright (c) 2012 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"implicit.html","title":"Implicit grant","type":"extras"},{"doc":"Code examplelib/my_app_web/resource_owners.exdefmodule MyApp.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by(username: username) do with %User{id: id, email: email} &lt;- Repo.get_by(User, email: username) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end def get_by(sub: sub) do with %User{id: id, email: email} = user &lt;- Repo.get_by(User, id: sub) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end @impl Boruta.Oauth.ResourceOwners def check_password(resource_owner, password) do User.check_password(user, password) end @impl Boruta.Oauth.ResourceOwners def authorized_scopes(%ResourceOwner{}), do: [] endlib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view endlib/my_app_web/templates/oauth/error.html.eex&lt;h1&gt;&lt;%= @error %&gt; - An error occured while authorizing request, check client OAuth configuration&lt;/h1&gt; &lt;p&gt;&lt;%= @error_description %&gt;&lt;/p&gt;lib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias MyAppWeb.OauthView def authorize(%Plug.Conn{query_params: query_params} = conn, _params) do current_user = conn.assigns[:current_user] conn = store_user_return_to(conn, query_params) Oauth.authorize( %ResourceOwner{sub: current_user.id, username: current_user.email}, conn, __MODULE__ ) end @impl Boruta.Oauth.Application def authorize_success( conn, %AuthorizeResponse{ type: type, redirect_uri: redirect_uri, value: value, expires_in: expires_in, state: state } ) do query_string = case state do nil -&gt; URI.encode_query(%{type =&gt; value, &quot;expires_in&quot; =&gt; expires_in}) state -&gt; URI.encode_query(%{type =&gt; value, &quot;expires_in&quot; =&gt; expires_in, &quot;state&quot; =&gt; state}) end url = case type do &quot;access_token&quot; -&gt; &quot;\#{redirect_uri}#\#{query_string}&quot; &quot;code&quot; -&gt; &quot;\#{redirect_uri}?\#{query_string}&quot; end redirect(conn, external: url) end @impl Boruta.Oauth.Application def authorize_error( conn, %Error{status: :unauthorized, error: :invalid_resource_owner} ) do # NOTE after siging in the user shall be redirected to `get_session(conn, :user_return_to)` redirect(conn, to: Routes.user_session_path(:new)) end def authorize_error( conn, %Error{ error: error, error_description: error_description, format: format, redirect_uri: redirect_uri } ) do query_string = URI.encode_query(%{error: error, error_description: error_description}) case format do :query -&gt; url = &quot;\#{redirect_uri}?\#{query_string}&quot; redirect(conn, external: url) :fragment -&gt; url = &quot;\#{redirect_uri}#\#{query_string}&quot; redirect(conn, external: url) _ -&gt; conn |&gt; put_status(status) |&gt; put_view(MyAppWeb.OauthView) |&gt; render(&quot;error.html&quot;, error: error, error_description: error_description) end end defp store_user_return_to(conn, params) do conn |&gt; put_session( :user_return_to, Routes.oauth_path(conn, :authorize, client_id: params[&quot;client_id&quot;], redirect_uri: params[&quot;redirect_uri&quot;], response_type: params[&quot;response_type&quot;], scope: params[&quot;scope&quot;], state: params[&quot;state&quot;] ) ) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :put_secure_browser_headers end scope &quot;/oauth&quot;, MyAppWeb do pipe_through [ :browser, :fetch_current_user # Out of OAuth scope, shall assign current_user to conn ] get &quot;/authorize&quot;, OauthController, :authorize end end","ref":"implicit.html#integration","title":"Implicit grant - Integration","type":"extras"},{"doc":"Introspect tokensAs stated in OAuth 2.0 Token Introspection RFC introspect provides a way to check token validity.POST /introspect HTTP/1.1 Host: server.example.com Accept: application/json Content-Type: application/x-www-form-urlencoded Authorization: Bearer 23410913-abewfq.123483 token=2YotnFZFEjr1zCsicMWpAA --- HTTP/1.1 200 OK Content-Type: application/json { &quot;active&quot;: true, &quot;client_id&quot;: &quot;l238j323ds-23ij4&quot;, &quot;username&quot;: &quot;jdoe&quot;, &quot;scope&quot;: &quot;read write dolphin&quot;, &quot;sub&quot;: &quot;Z5O3upPC88QrAjx00dis&quot;, &quot;aud&quot;: &quot;https://protected.example.net/resource&quot;, &quot;iss&quot;: &quot;https://server.example.com/&quot;, &quot;exp&quot;: 1419356238, &quot;iat&quot;: 1419350238, &quot;extension_field&quot;: &quot;twenty-seven&quot; }Copyright (c) 2015 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"introspect.html","title":"Introspect tokens","type":"extras"},{"doc":"Code examplelib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view alias Boruta.Oauth.IntrospectResponse def render(&quot;introspect.json&quot;, %{response: %IntrospectResponse{active: false}}) do %{&quot;active&quot; =&gt; false} end def render(&quot;introspect.json&quot;, %{response: %IntrospectResponse{ active: active, client_id: client_id, username: username, scope: scope, sub: sub, iss: iss, exp: exp, iat: iat }}) do %{ active: true, client_id: client_id, username: username, scope: scope, sub: sub, iss: iss, exp: exp, iat: iat } end def render(&quot;error.json&quot;, %{error: error, error_description: error_description}) do %{ error: error, error_description: error_description } end endlib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias Boruta.Oauth.IntrospectResponse alias MyAppWeb.OauthView def introspect(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.introspect(__MODULE__) end @impl Boruta.Oauth.Application def introspect_success(conn, %IntrospectResponse{} = response) do conn |&gt; put_view(OauthView) |&gt; render(&quot;introspect.json&quot;, response: response) end @impl Boruta.Oauth.Application def introspect_error(conn, %Error{ status: status, error: error, error_description: error_description }) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/oauth&quot;, MyAppWeb do pipe_through :api post &quot;/introspect&quot;, OauthController, :introspect end end","ref":"introspect.html#integration","title":"Introspect tokens - Integration","type":"extras"},{"doc":"Revoke tokensAs stated in OAuth 2.0 Token Revocation RFC revocation provides a way to revoke tokens.POST /revoke HTTP/1.1 Host: server.example.com Content-Type: application/x-www-form-urlencoded Authorization: Basic czZCaGRSa3F0MzpnWDFmQmF0M2JW token=45ghiukldjahdnhzdauz&amp;token_type_hint=refresh_token --- HTTP/1.1 200 OKCopyright (c) 2012 IETF Trust and the persons identified as authors of the code. All rights reserved.Redistribution and use in source and binary forms, with or without modification, is permitted pursuant to, and subject to the license terms contained in, the Simplified BSD License set forth in Section 4.c of the IETF Trust’s Legal Provisions Relating to IETF Documents (http://trustee.ietf.org/license-info).","ref":"revoke.html","title":"Revoke tokens","type":"extras"},{"doc":"Code examplelib/my_app_web/views/oauth_view.exdefmodule MyAppWeb.OauthView do use MyAppWeb, :view def render(&quot;error.json&quot;, %{error: error, error_description: error_description}) do %{ error: error, error_description: error_description } end endlib/my_app_web/controllers/oauth_controller.exdefmodule MyAppWeb.OauthController do @behaviour Boruta.Oauth.Application use MyAppWeb, :controller alias Boruta.Oauth alias Boruta.Oauth.Error alias MyAppWeb.OauthView def revoke(%Plug.Conn{} = conn, _params) do conn |&gt; Oauth.revoke(__MODULE__) end @impl Boruta.Oauth.Application def revoke_success(%Plug.Conn{} = conn) do send_resp(conn, 200, &quot;&quot;) end @impl Boruta.Oauth.Application def revoke_error(conn, %Error{ status: status, error: error, error_description: error_description }) do conn |&gt; put_status(status) |&gt; put_view(OauthView) |&gt; render(&quot;error.json&quot;, error: error, error_description: error_description) end endlib/my_app_web/router.exdefmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/oauth&quot;, MyAppWeb do pipe_through :api post &quot;/revoke&quot;, OauthController, :revoke end end","ref":"revoke.html#integration","title":"Revoke tokens - Integration","type":"extras"}]